
(* lexical analyzer template (TP Lex V3.0), V1.0 3-2-91 AG *)

(* global definitions: *)

var
   i: integer;



function yylex : Integer;

procedure yyaction ( yyruleno : Integer );
  (* local definitions: *)

begin
  (* actions: *)
  case yyruleno of
  1:
        begin
             writeln (yylineno, 'TK: ', yytext);
             yylval.yyministring:= yytext;
             return (ENTERO);
        end;

  2:
                        begin
                             for i:= 1 to yyleng do
                                yytext[i]:= upcase (yytext[i]);
                             writeln (yylineno,' TK:', yytext);
                             if yytext='PROGRAM' then
                                return (_PROGRAM)
                             else if yytext='CONST' then
                                     return (_CONST)
                             else if yytext='TYPE' then
                                     return (_TYPE)
                             else if yytext='VAR' then
                                     return (_VAR)
                             else if yytext= 'ARRAY' then
                                     return (_ARRAY)
                             else if yytext= 'OF' then
                                     return (_OF)
                             else if yytext='PROCEDURE' then
                                     return (_PROCEDURE)
                             else if yytext='BEGIN' then
                                     return (_BEGIN)
                             else if yytext='END' then
                                     return (_END)
                             else begin
                                     if yytext='INTEGER' then
                                        yylval.yytiporegistro.tipo:=1;
                                     yylval.yytiporegistro.valor:= yytext;
                                     return (IDENT);
                                  end; 
                        end;

  3:
        begin
             writeln (yylineno,' TK: ', yytext);
             return (ASIGNACION); 
        end;
  4:
        begin
             writeln (yylineno,' TK: ', yytext);
             return (PUNTOPUNTO); 
        end;

  5,
  6,
  7,
  8,
  9,
  10,
  11,
  12,
  13,
  14:
        begin
             writeln (yylineno, 'TK: ', yytext);
             returnc (yytext[1]); 
        end;

  15,
  16,
  17:
        ;

  18:
        begin
             writeln ('ERROR LEXICOGRFICO: ', yytext[1]);
             halt;
        end;

  end;
end(*yyaction*);

(* DFA table: *)

type YYTRec = record
                cc : set of Char;
                s  : Integer;
              end;

const

yynmarks   = 34;
yynmatches = 34;
yyntrans   = 38;
yynstates  = 22;

yyk : array [1..yynmarks] of Integer = (
  { 0: }
  { 1: }
  { 2: }
  1,
  18,
  { 3: }
  2,
  18,
  { 4: }
  9,
  18,
  { 5: }
  13,
  18,
  { 6: }
  5,
  18,
  { 7: }
  6,
  18,
  { 8: }
  7,
  18,
  { 9: }
  8,
  18,
  { 10: }
  10,
  18,
  { 11: }
  11,
  18,
  { 12: }
  12,
  18,
  { 13: }
  14,
  18,
  { 14: }
  15,
  18,
  { 15: }
  16,
  18,
  { 16: }
  17,
  { 17: }
  18,
  { 18: }
  1,
  { 19: }
  2,
  { 20: }
  3,
  { 21: }
  4
);

yym : array [1..yynmatches] of Integer = (
{ 0: }
{ 1: }
{ 2: }
  1,
  18,
{ 3: }
  2,
  18,
{ 4: }
  9,
  18,
{ 5: }
  13,
  18,
{ 6: }
  5,
  18,
{ 7: }
  6,
  18,
{ 8: }
  7,
  18,
{ 9: }
  8,
  18,
{ 10: }
  10,
  18,
{ 11: }
  11,
  18,
{ 12: }
  12,
  18,
{ 13: }
  14,
  18,
{ 14: }
  15,
  18,
{ 15: }
  16,
  18,
{ 16: }
  17,
{ 17: }
  18,
{ 18: }
  1,
{ 19: }
  2,
{ 20: }
  3,
{ 21: }
  4
);

yyt : array [1..yyntrans] of YYTrec = (
{ 0: }
  ( cc: [ #1..#8,#11..#31,'!'..'''','*','+','-','/',
            '<','>'..'@','\','_','`','{'..#255 ]; s: 17),
  ( cc: [ #9 ]; s: 15),
  ( cc: [ #10 ]; s: 16),
  ( cc: [ ' ' ]; s: 14),
  ( cc: [ '(' ]; s: 6),
  ( cc: [ ')' ]; s: 7),
  ( cc: [ ',' ]; s: 9),
  ( cc: [ '.' ]; s: 5),
  ( cc: [ '0'..'9' ]; s: 2),
  ( cc: [ ':' ]; s: 4),
  ( cc: [ ';' ]; s: 8),
  ( cc: [ '=' ]; s: 10),
  ( cc: [ 'A'..'Z','a'..'z' ]; s: 3),
  ( cc: [ '[' ]; s: 11),
  ( cc: [ ']' ]; s: 12),
  ( cc: [ '^' ]; s: 13),
{ 1: }
  ( cc: [ #1..#8,#11..#31,'!'..'''','*','+','-','/',
            '<','>'..'@','\','_','`','{'..#255 ]; s: 17),
  ( cc: [ #9 ]; s: 15),
  ( cc: [ #10 ]; s: 16),
  ( cc: [ ' ' ]; s: 14),
  ( cc: [ '(' ]; s: 6),
  ( cc: [ ')' ]; s: 7),
  ( cc: [ ',' ]; s: 9),
  ( cc: [ '.' ]; s: 5),
  ( cc: [ '0'..'9' ]; s: 2),
  ( cc: [ ':' ]; s: 4),
  ( cc: [ ';' ]; s: 8),
  ( cc: [ '=' ]; s: 10),
  ( cc: [ 'A'..'Z','a'..'z' ]; s: 3),
  ( cc: [ '[' ]; s: 11),
  ( cc: [ ']' ]; s: 12),
  ( cc: [ '^' ]; s: 13),
{ 2: }
  ( cc: [ '0'..'9' ]; s: 18),
{ 3: }
  ( cc: [ '0'..'9','A'..'Z','a'..'z' ]; s: 19),
{ 4: }
  ( cc: [ '=' ]; s: 20),
{ 5: }
  ( cc: [ '.' ]; s: 21),
{ 6: }
{ 7: }
{ 8: }
{ 9: }
{ 10: }
{ 11: }
{ 12: }
{ 13: }
{ 14: }
{ 15: }
{ 16: }
{ 17: }
{ 18: }
  ( cc: [ '0'..'9' ]; s: 18),
{ 19: }
  ( cc: [ '0'..'9','A'..'Z','a'..'z' ]; s: 19)
{ 20: }
{ 21: }
);

yykl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 1,
{ 3: } 3,
{ 4: } 5,
{ 5: } 7,
{ 6: } 9,
{ 7: } 11,
{ 8: } 13,
{ 9: } 15,
{ 10: } 17,
{ 11: } 19,
{ 12: } 21,
{ 13: } 23,
{ 14: } 25,
{ 15: } 27,
{ 16: } 29,
{ 17: } 30,
{ 18: } 31,
{ 19: } 32,
{ 20: } 33,
{ 21: } 34
);

yykh : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 2,
{ 3: } 4,
{ 4: } 6,
{ 5: } 8,
{ 6: } 10,
{ 7: } 12,
{ 8: } 14,
{ 9: } 16,
{ 10: } 18,
{ 11: } 20,
{ 12: } 22,
{ 13: } 24,
{ 14: } 26,
{ 15: } 28,
{ 16: } 29,
{ 17: } 30,
{ 18: } 31,
{ 19: } 32,
{ 20: } 33,
{ 21: } 34
);

yyml : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 1,
{ 3: } 3,
{ 4: } 5,
{ 5: } 7,
{ 6: } 9,
{ 7: } 11,
{ 8: } 13,
{ 9: } 15,
{ 10: } 17,
{ 11: } 19,
{ 12: } 21,
{ 13: } 23,
{ 14: } 25,
{ 15: } 27,
{ 16: } 29,
{ 17: } 30,
{ 18: } 31,
{ 19: } 32,
{ 20: } 33,
{ 21: } 34
);

yymh : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 2,
{ 3: } 4,
{ 4: } 6,
{ 5: } 8,
{ 6: } 10,
{ 7: } 12,
{ 8: } 14,
{ 9: } 16,
{ 10: } 18,
{ 11: } 20,
{ 12: } 22,
{ 13: } 24,
{ 14: } 26,
{ 15: } 28,
{ 16: } 29,
{ 17: } 30,
{ 18: } 31,
{ 19: } 32,
{ 20: } 33,
{ 21: } 34
);

yytl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 17,
{ 2: } 33,
{ 3: } 34,
{ 4: } 35,
{ 5: } 36,
{ 6: } 37,
{ 7: } 37,
{ 8: } 37,
{ 9: } 37,
{ 10: } 37,
{ 11: } 37,
{ 12: } 37,
{ 13: } 37,
{ 14: } 37,
{ 15: } 37,
{ 16: } 37,
{ 17: } 37,
{ 18: } 37,
{ 19: } 38,
{ 20: } 39,
{ 21: } 39
);

yyth : array [0..yynstates-1] of Integer = (
{ 0: } 16,
{ 1: } 32,
{ 2: } 33,
{ 3: } 34,
{ 4: } 35,
{ 5: } 36,
{ 6: } 36,
{ 7: } 36,
{ 8: } 36,
{ 9: } 36,
{ 10: } 36,
{ 11: } 36,
{ 12: } 36,
{ 13: } 36,
{ 14: } 36,
{ 15: } 36,
{ 16: } 36,
{ 17: } 36,
{ 18: } 37,
{ 19: } 38,
{ 20: } 38,
{ 21: } 38
);


var yyn : Integer;

label start, scan, action;

begin

start:

  (* initialize: *)

  yynew;

scan:

  (* mark positions and matches: *)

  for yyn := yykl[yystate] to     yykh[yystate] do yymark(yyk[yyn]);
  for yyn := yymh[yystate] downto yyml[yystate] do yymatch(yym[yyn]);

  if yytl[yystate]>yyth[yystate] then goto action; (* dead state *)

  (* get next character: *)

  yyscan;

  (* determine action: *)

  yyn := yytl[yystate];
  while (yyn<=yyth[yystate]) and not (yyactchar in yyt[yyn].cc) do inc(yyn);
  if yyn>yyth[yystate] then goto action;
    (* no transition on yyactchar in this state *)

  (* switch to new state: *)

  yystate := yyt[yyn].s;

  goto scan;

action:

  (* execute action: *)

  if yyfind(yyrule) then
    begin
      yyaction(yyrule);
      if yyreject then goto action;
    end
  else if not yydefault and yywrap then
    begin
      yyclear;
      return(0);
    end;

  if not yydone then goto start;

  yylex := yyretval;

end(*yylex*);


