%{

var
   i: integer;

%}

%%

[0-9]+  begin
             writeln (yylineno, 'TK: ', yytext);
             yylval.yyministring:= yytext;
             return (ENTERO);
        end;

[a-zA-Z][a-zA-Z0-9]*    begin
                             for i:= 1 to yyleng do
                                yytext[i]:= upcase (yytext[i]);
                             writeln (yylineno,' TK:', yytext);
                             if yytext='PROGRAM' then
                                return (_PROGRAM)
                             else if yytext='CONST' then
                                     return (_CONST)
                             else if yytext='TYPE' then
                                     return (_TYPE)
                             else if yytext='VAR' then
                                     return (_VAR)
                             else if yytext= 'ARRAY' then
                                     return (_ARRAY)
                             else if yytext= 'OF' then
                                     return (_OF)
                             else if yytext='PROCEDURE' then
                                     return (_PROCEDURE)
                             else if yytext='BEGIN' then
                                     return (_BEGIN)
                             else if yytext='END' then
                                     return (_END)
                             else begin
                                     if yytext='INTEGER' then
                                        yylval.yytiporegistro.tipo:=1;
                                     yylval.yytiporegistro.valor:= yytext;
                                     return (IDENT);
                                  end; 
                        end;

":="    begin
             writeln (yylineno,' TK: ', yytext);
             return (ASIGNACION); 
        end;
".."    begin
             writeln (yylineno,' TK: ', yytext);
             return (PUNTOPUNTO); 
        end;

"("     |
")"     |
";"     |
","     |
":"     |
"="     |
"["     |
"]"     |
"."     |
"^"     begin
             writeln (yylineno, 'TK: ', yytext);
             returnc (yytext[1]); 
        end;

" "     |
\t      |
\n      ;

.       begin
             writeln ('ERROR LEXICOGRFICO: ', yytext[1]);
             halt;
        end;

%%
